Index: uspace/lib/display/test/display.c
===================================================================
--- uspace/lib/display/test/display.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/display/test/display.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1011,6 +1411,119 @@
 	display_window_destroy(wnd);
 	display_close(disp);
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
+}
+
+/** display_window_set_caption() with server returning error response works. */
+PCUT_TEST(window_set_caption_failure)
+{
+	errno_t rc;
+	service_id_t sid;
+	display_t *disp = NULL;
+	display_wnd_params_t params;
+	display_window_t *wnd;
+	const char *caption;
+	test_response_t resp;
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_open(test_display_svc, &disp);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(disp);
+
+	resp.rc = EOK;
+	display_wnd_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
+
+	rc = display_window_create(disp, &params, &test_display_wnd_cb,
+	    (void *) &resp, &wnd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(wnd);
+
+	caption = "Hello";
+
+	resp.rc = EIO;
+	resp.window_set_caption_called = false;
+
+	rc = display_window_set_caption(wnd, caption);
+	PCUT_ASSERT_INT_EQUALS(wnd->id, resp.set_caption_wnd_id);
+	PCUT_ASSERT_TRUE(resp.window_set_caption_called);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
+	PCUT_ASSERT_INT_EQUALS(0, str_cmp(caption, resp.set_caption_caption));
+
+	//free(resp.set_caption_caption);
+	display_window_destroy(wnd);
+	display_close(disp);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
+}
+
+/** display_window_set_caption() with server returning success response works. */
+PCUT_TEST(window_set_caption_success)
+{
+	errno_t rc;
+	service_id_t sid;
+	display_t *disp = NULL;
+	display_wnd_params_t params;
+	display_window_t *wnd;
+	const char *caption;
+	test_response_t resp;
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_open(test_display_svc, &disp);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(disp);
+
+	resp.rc = EOK;
+	display_wnd_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
+
+	rc = display_window_create(disp, &params, &test_display_wnd_cb,
+	    (void *) &resp, &wnd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(wnd);
+
+	caption = "Hello";
+
+	resp.rc = EOK;
+	resp.window_set_caption_called = false;
+
+	rc = display_window_set_caption(wnd, caption);
+	PCUT_ASSERT_INT_EQUALS(wnd->id, resp.set_caption_wnd_id);
+	PCUT_ASSERT_TRUE(resp.window_set_caption_called);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
+	PCUT_ASSERT_INT_EQUALS(0, str_cmp(caption, resp.set_caption_caption));
+
+	//free(resp.set_caption_caption);
+	display_window_destroy(wnd);
+	display_close(disp);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1025,12 +1538,13 @@
 	test_response_t resp;
 	gfx_context_t *gc;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1063,6 +1577,7 @@
 
 	display_close(disp);
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1078,12 +1593,13 @@
 	gfx_context_t *gc;
 	gfx_color_t *color;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1124,6 +1640,7 @@
 
 	display_close(disp);
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1137,12 +1654,13 @@
 	display_window_t *wnd;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1189,6 +1707,7 @@
 	display_close(disp);
 
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1202,12 +1721,13 @@
 	display_window_t *wnd;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1232,4 +1752,5 @@
 	resp.event_cnt = 1;
 	resp.event.etype = wev_focus;
+	resp.event.ev.focus.nfocus = 42;
 	resp.wnd_id = wnd->id;
 	resp.focus_event_called = false;
@@ -1248,4 +1769,6 @@
 	PCUT_ASSERT_INT_EQUALS(resp.event.etype,
 	    resp.revent.etype);
+	PCUT_ASSERT_INT_EQUALS(resp.event.ev.focus.nfocus,
+	    resp.revent.ev.focus.nfocus);
 
 	rc = display_window_destroy(wnd);
@@ -1254,6 +1777,7 @@
 	display_close(disp);
 
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1267,12 +1791,13 @@
 	display_window_t *wnd;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1331,6 +1856,7 @@
 	display_close(disp);
 
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1344,12 +1870,13 @@
 	display_window_t *wnd;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1408,6 +1935,7 @@
 	display_close(disp);
 
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1421,12 +1949,13 @@
 	display_window_t *wnd;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1451,4 +1980,5 @@
 	resp.event_cnt = 1;
 	resp.event.etype = wev_unfocus;
+	resp.event.ev.unfocus.nfocus = 42;
 	resp.wnd_id = wnd->id;
 	resp.unfocus_event_called = false;
@@ -1467,4 +1997,6 @@
 	PCUT_ASSERT_INT_EQUALS(resp.event.etype,
 	    resp.revent.etype);
+	PCUT_ASSERT_INT_EQUALS(resp.event.ev.focus.nfocus,
+	    resp.revent.ev.focus.nfocus);
 
 	rc = display_window_destroy(wnd);
@@ -1473,6 +2005,7 @@
 	display_close(disp);
 
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1485,12 +2018,13 @@
 	display_info_t info;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1507,6 +2041,7 @@
 
 	display_close(disp);
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1519,12 +2054,13 @@
 	display_info_t info;
 	test_response_t resp;
-
-	async_set_fallback_port_handler(test_display_conn, &resp);
-
-	// FIXME This causes this test to be non-reentrant!
-	rc = loc_server_register(test_display_server);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = loc_service_register(test_display_svc, &sid);
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_display_svc, &sid);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -1549,6 +2085,7 @@
 
 	display_close(disp);
-	rc = loc_service_unregister(sid);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
 }
 
@@ -1612,9 +2149,10 @@
 }
 
-static void test_focus_event(void *arg)
+static void test_focus_event(void *arg, unsigned nfocus)
 {
 	test_response_t *resp = (test_response_t *) arg;
 
 	resp->revent.etype = wev_focus;
+	resp->revent.ev.focus.nfocus = nfocus;
 
 	fibril_mutex_lock(&resp->event_lock);
@@ -1650,9 +2188,10 @@
 }
 
-static void test_unfocus_event(void *arg)
+static void test_unfocus_event(void *arg, unsigned nfocus)
 {
 	test_response_t *resp = (test_response_t *) arg;
 
 	resp->revent.etype = wev_unfocus;
+	resp->revent.ev.unfocus.nfocus = nfocus;
 
 	fibril_mutex_lock(&resp->event_lock);
@@ -1670,4 +2209,5 @@
 	resp->create_rect = params->rect;
 	resp->create_min_size = params->min_size;
+	resp->create_idev_id = params->idev_id;
 	if (resp->rc == EOK)
 		*rwnd_id = resp->wnd_id;
@@ -1686,5 +2226,5 @@
 
 static errno_t test_window_move_req(void *arg, sysarg_t wnd_id,
-    gfx_coord2_t *pos)
+    gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	test_response_t *resp = (test_response_t *) arg;
@@ -1693,4 +2233,5 @@
 	resp->move_req_wnd_id = wnd_id;
 	resp->move_req_pos = *pos;
+	resp->move_req_pos_id = pos_id;
 	return resp->rc;
 }
@@ -1719,6 +2260,20 @@
 }
 
+static errno_t test_window_get_max_rect(void *arg, sysarg_t wnd_id,
+    gfx_rect_t *rect)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_get_max_rect_called = true;
+	resp->get_max_rect_wnd_id = wnd_id;
+
+	if (resp->rc == EOK)
+		*rect = resp->get_max_rect_rrect;
+
+	return resp->rc;
+}
+
 static errno_t test_window_resize_req(void *arg, sysarg_t wnd_id,
-    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos)
+    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	test_response_t *resp = (test_response_t *) arg;
@@ -1728,4 +2283,5 @@
 	resp->resize_req_wnd_id = wnd_id;
 	resp->resize_req_pos = *pos;
+	resp->resize_req_pos_id = pos_id;
 	return resp->rc;
 }
@@ -1743,4 +2299,31 @@
 }
 
+static errno_t test_window_minimize(void *arg, sysarg_t wnd_id)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_minimize_called = true;
+	resp->resize_wnd_id = wnd_id;
+	return resp->rc;
+}
+
+static errno_t test_window_maximize(void *arg, sysarg_t wnd_id)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_maximize_called = true;
+	resp->resize_wnd_id = wnd_id;
+	return resp->rc;
+}
+
+static errno_t test_window_unmaximize(void *arg, sysarg_t wnd_id)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_unmaximize_called = true;
+	resp->resize_wnd_id = wnd_id;
+	return resp->rc;
+}
+
 static errno_t test_window_set_cursor(void *arg, sysarg_t wnd_id,
     display_stock_cursor_t cursor)
@@ -1751,4 +2334,16 @@
 	resp->set_cursor_wnd_id = wnd_id;
 	resp->set_cursor_cursor = cursor;
+
+	return resp->rc;
+}
+
+static errno_t test_window_set_caption(void *arg, sysarg_t wnd_id,
+    const char *caption)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_set_caption_called = true;
+	resp->set_caption_wnd_id = wnd_id;
+	resp->set_caption_caption = str_dup(caption);
 
 	return resp->rc;
Index: uspace/lib/dltest/dltest.c
===================================================================
--- uspace/lib/dltest/dltest.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/dltest/dltest.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2016 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -43,4 +43,6 @@
 /** Public initialized variable */
 int dl_public_var = dl_public_var_val;
+/** Public variable initialized with the address of a symbol */
+int *dl_public_ptr_var = &dl_public_var;
 /** Public uninitialized variable */
 int dl_public_uvar;
Index: uspace/lib/dltest/libdltest.h
===================================================================
--- uspace/lib/dltest/libdltest.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/dltest/libdltest.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2016 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -67,4 +67,5 @@
 extern int dl_public_var;
 extern int dl_public_uvar;
+extern int *dl_public_ptr_var;
 extern fibril_local int dl_public_fib_var;
 extern fibril_local int dl_public_fib_uvar;
Index: uspace/lib/drv/generic/interrupt.c
===================================================================
--- uspace/lib/drv/generic/interrupt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/generic/interrupt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -43,9 +44,10 @@
 
 errno_t register_interrupt_handler(ddf_dev_t *dev, int irq,
-    interrupt_handler_t *handler, const irq_code_t *irq_code,
+    interrupt_handler_t *handler, void *arg, const irq_code_t *irq_code,
     cap_irq_handle_t *handle)
 {
+	(void)dev;
 	return async_irq_subscribe(irq, (async_notification_handler_t) handler,
-	    dev, irq_code, handle);
+	    arg, irq_code, handle);
 }
 
Index: uspace/lib/drv/generic/remote_hw_res.c
===================================================================
--- uspace/lib/drv/generic/remote_hw_res.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/generic/remote_hw_res.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * Copyright (c) 2011 Jan Vesely
@@ -47,4 +48,5 @@
 static void remote_hw_res_dma_channel_setup(ddf_fun_t *, void *, ipc_call_t *);
 static void remote_hw_res_dma_channel_remain(ddf_fun_t *, void *, ipc_call_t *);
+static void remote_hw_res_get_flags(ddf_fun_t *, void *, ipc_call_t *);
 
 static const remote_iface_func_ptr_t remote_hw_res_iface_ops [] = {
@@ -55,4 +57,5 @@
 	[HW_RES_DMA_CHANNEL_SETUP] = &remote_hw_res_dma_channel_setup,
 	[HW_RES_DMA_CHANNEL_REMAIN] = &remote_hw_res_dma_channel_remain,
+	[HW_RES_GET_FLAGS] = &remote_hw_res_get_flags
 };
 
@@ -103,5 +106,5 @@
 
 	const int irq = DEV_IPC_GET_ARG1(*call);
-	const errno_t ret = hw_res_ops->enable_interrupt(fun, irq);
+	const errno_t ret = hw_res_ops->clear_interrupt(fun, irq);
 	async_answer_0(call, ret);
 }
@@ -171,4 +174,19 @@
 }
 
+static void remote_hw_res_get_flags(ddf_fun_t *fun, void *ops,
+    ipc_call_t *call)
+{
+	hw_res_ops_t *hw_res_ops = ops;
+
+	if (hw_res_ops->get_flags == NULL) {
+		async_answer_0(call, ENOTSUP);
+		return;
+	}
+
+	hw_res_flags_t flags = 0;
+	const errno_t ret = hw_res_ops->get_flags(fun, &flags);
+	async_answer_1(call, ret, flags);
+}
+
 /**
  * @}
Index: uspace/lib/drv/include/ddf/interrupt.h
===================================================================
--- uspace/lib/drv/include/ddf/interrupt.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/include/ddf/interrupt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -48,8 +49,8 @@
  */
 
-typedef void interrupt_handler_t(ipc_call_t *, ddf_dev_t *);
+typedef void interrupt_handler_t(ipc_call_t *, void *);
 
-extern errno_t register_interrupt_handler(ddf_dev_t *, int, interrupt_handler_t *,
-    const irq_code_t *, cap_irq_handle_t *);
+extern errno_t register_interrupt_handler(ddf_dev_t *, int,
+    interrupt_handler_t *, void *, const irq_code_t *, cap_irq_handle_t *);
 extern errno_t unregister_interrupt_handler(ddf_dev_t *, cap_irq_handle_t);
 
Index: uspace/lib/drv/include/ops/hw_res.h
===================================================================
--- uspace/lib/drv/include/ops/hw_res.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/drv/include/ops/hw_res.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * Copyright (c) 2011 Jan Vesely
@@ -49,4 +50,5 @@
 	errno_t (*dma_channel_setup)(ddf_fun_t *, unsigned, uint32_t, uint32_t, uint8_t);
 	errno_t (*dma_channel_remain)(ddf_fun_t *, unsigned, size_t *);
+	errno_t (*get_flags)(ddf_fun_t *, hw_res_flags_t *);
 } hw_res_ops_t;
 
Index: uspace/lib/ext4/include/ext4/types.h
===================================================================
--- uspace/lib/ext4/include/ext4/types.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ext4/include/ext4/types.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -141,5 +141,5 @@
 	uint32_t encrypt_algos;             /* Encrypt algorithm in use */
 	uint32_t padding[105];              /* Padding to the end of the block */
-} __attribute__((packed)) ext4_superblock_t;
+} ext4_superblock_t;
 
 #define EXT4_GOOD_OLD_REV 0
@@ -335,5 +335,5 @@
 			uint32_t author;
 		} hurd2;
-	} __attribute__((packed)) osd2;
+	} osd2;
 
 	uint16_t extra_isize;
@@ -345,5 +345,5 @@
 	uint32_t crtime_extra;  /* Extra file creation time (nsec << 2 | epoch) */
 	uint32_t version_hi;    /* High 32 bits for 64-bit version */
-} __attribute__((packed)) ext4_inode_t;
+} ext4_inode_t;
 
 #define EXT4_INODE_MODE_FIFO       0x1000
@@ -418,8 +418,8 @@
 		uint8_t name_length_high;  /* Higher 8 bits of name length */
 		uint8_t inode_type;        /* Type of referenced inode (in rev >= 0.5) */
-	} __attribute__((packed));
+	};
 
 	uint8_t name[EXT4_DIRECTORY_FILENAME_LEN];  /* Entry name */
-} __attribute__((packed)) ext4_directory_entry_ll_t;
+} ext4_directory_entry_ll_t;
 
 typedef struct ext4_directory_iterator {
Index: uspace/lib/ext4/src/extent.c
===================================================================
--- uspace/lib/ext4/src/extent.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ext4/src/extent.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -643,5 +643,5 @@
 
 	uint16_t delete_count = block_count -
-	    (ext4_extent_get_start(path_ptr->extent) - first_fblock);
+	    (first_fblock - ext4_extent_get_start(path_ptr->extent));
 
 	/* Release all blocks */
Index: uspace/lib/ext4/src/filesystem.c
===================================================================
--- uspace/lib/ext4/src/filesystem.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ext4/src/filesystem.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2018 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Sucha
  * Copyright (c) 2012 Frantisek Princ
@@ -83,5 +83,5 @@
 
 	/* Initialize block library (4096 is size of communication channel) */
-	rc = block_init(fs->device, 4096);
+	rc = block_init(fs->device);
 	if (rc != EOK)
 		goto err;
@@ -265,5 +265,5 @@
 
 	/* Initialize block library (4096 is size of communication channel) */
-	rc = block_init(service_id, 4096);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		goto err;
Index: uspace/lib/ext4/src/ops.c
===================================================================
--- uspace/lib/ext4/src/ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ext4/src/ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -122,5 +122,5 @@
 }
 
-static hash_table_ops_t open_nodes_ops = {
+static const hash_table_ops_t open_nodes_ops = {
 	.hash = open_nodes_hash,
 	.key_hash = open_nodes_key_hash,
@@ -810,15 +810,14 @@
 }
 
-/** Extract device identifier from node.
+/** Get service ID for a service-special file.
  *
  * @param node Node to extract id from
  *
- * @return id of device, where is the filesystem
+ * @return Service ID for a service-special file, zero for a regular file.
  *
  */
 service_id_t ext4_service_get(fs_node_t *fn)
 {
-	ext4_node_t *enode = EXT4_NODE(fn);
-	return enode->instance->service_id;
+	return 0;
 }
 
Index: uspace/lib/fdisk/src/fdisk.c
===================================================================
--- uspace/lib/fdisk/src/fdisk.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/fdisk/src/fdisk.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -810,7 +810,16 @@
 }
 
+/** Destroy partition.
+ *
+ * @param part Partition
+ * @return EOK on success or error code
+ */
 errno_t fdisk_part_destroy(fdisk_part_t *part)
 {
 	errno_t rc;
+
+	rc = vol_part_eject(part->dev->fdisk->vol, part->svc_id);
+	if (rc != EOK)
+		return EIO;
 
 	rc = vbd_part_delete(part->dev->fdisk->vbd, part->part_id);
Index: uspace/lib/fmtutil/meson.build
===================================================================
--- uspace/lib/fmtutil/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/fmtutil/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'console' ]
 src = files('fmtutil.c')
Index: uspace/lib/gfx/src/color.c
===================================================================
--- uspace/lib/gfx/src/color.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfx/src/color.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -64,4 +64,5 @@
 	color->g = g;
 	color->b = b;
+	color->attr = 0xff;
 
 	*rcolor = color;
Index: uspace/lib/gfxfont/include/gfx/text.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/text.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/include/gfx/text.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,4 +38,5 @@
 
 #include <errno.h>
+#include <stddef.h>
 #include <types/gfx/coord.h>
 #include <types/gfx/font.h>
@@ -44,14 +45,13 @@
 extern void gfx_text_fmt_init(gfx_text_fmt_t *);
 extern gfx_coord_t gfx_text_width(gfx_font_t *, const char *);
-extern errno_t gfx_puttext(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *);
-extern void gfx_text_start_pos(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_coord2_t *);
-extern size_t gfx_text_find_pos(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_coord2_t *);
-extern void gfx_text_cont(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_coord2_t *, gfx_text_fmt_t *);
-extern void gfx_text_rect(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
-    const char *, gfx_rect_t *);
+extern errno_t gfx_puttext(gfx_coord2_t *, gfx_text_fmt_t *, const char *);
+extern void gfx_text_start_pos(gfx_coord2_t *, gfx_text_fmt_t *, const char *,
+    gfx_coord2_t *);
+extern size_t gfx_text_find_pos(gfx_coord2_t *, gfx_text_fmt_t *, const char *,
+    gfx_coord2_t *);
+extern void gfx_text_cont(gfx_coord2_t *, gfx_text_fmt_t *, const char *,
+    gfx_coord2_t *, gfx_text_fmt_t *);
+extern void gfx_text_rect(gfx_coord2_t *, gfx_text_fmt_t *, const char *,
+    gfx_rect_t *);
 
 #endif
Index: uspace/lib/gfxfont/include/types/gfx/text.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/text.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/include/types/gfx/text.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,4 +37,5 @@
 #define _TYPES_GFX_TEXT_H
 
+#include <stdbool.h>
 #include <types/gfx/coord.h>
 #include <types/gfx/color.h>
@@ -66,12 +67,18 @@
 /** Text formatting */
 typedef struct {
+	/** Text font */
+	struct gfx_font *font;
 	/** Text color */
 	gfx_color_t *color;
 	/** Horizontal alignment */
 	gfx_halign_t halign;
-	/** Justification width (for gfx_halign_justify) */
-	gfx_coord_t justify_width;
+	/** Width available for the text */
+	gfx_coord_t width;
 	/** Vertical alignment */
 	gfx_valign_t valign;
+	/** Abbreviate the text with ellipsis if it does not fit @c width */
+	bool abbreviate;
+	/** Underline */
+	bool underline;
 } gfx_text_fmt_t;
 
Index: uspace/lib/gfxfont/include/types/gfx/typeface.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/typeface.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/include/types/gfx/typeface.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -50,4 +50,8 @@
 	/** Leading */
 	gfx_coord_t leading;
+	/** Underline start Y coordinate (inclusive) */
+	gfx_coord_t underline_y0;
+	/** Underline end Y coordinate (exclusive) */
+	gfx_coord_t underline_y1;
 } gfx_font_metrics_t;
 
Index: uspace/lib/gfxfont/private/tpf_file.h
===================================================================
--- uspace/lib/gfxfont/private/tpf_file.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/private/tpf_file.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -76,4 +76,6 @@
 	uint16_t descent;
 	uint16_t leading;
+	int16_t underline_y0;
+	int16_t underline_y1;
 } tpf_font_metrics_t;
 
Index: uspace/lib/gfxfont/src/font.c
===================================================================
--- uspace/lib/gfxfont/src/font.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/src/font.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -546,4 +546,6 @@
 	metrics->descent = uint16_t_le2host(tmetrics.descent);
 	metrics->leading = uint16_t_le2host(tmetrics.leading);
+	metrics->underline_y0 = uint16_t_le2host(tmetrics.underline_y0);
+	metrics->underline_y1 = uint16_t_le2host(tmetrics.underline_y1);
 	return EOK;
 }
@@ -565,4 +567,6 @@
 	tmetrics.descent = host2uint16_t_le(metrics->descent);
 	tmetrics.leading = host2uint16_t_le(metrics->leading);
+	tmetrics.underline_y0 = host2uint16_t_le(metrics->underline_y0);
+	tmetrics.underline_y1 = host2uint16_t_le(metrics->underline_y1);
 
 	rc = riff_wchunk_start(riffw, CKID_fmtr, &mtrck);
